// This is based on exxile's All-in-one-sidebar modification of Dorando's keyconfig extension (http://www.extensionsmirror.nl/index.php?showtopic=254).

var target;
if(window.opener.deliciousKeyconfig) target = window.opener;
else if(window.opener.opener && window.opener.opener.deliciousKeyconfig) target = window.opener.opener;
else if(window.opener.parent && window.opener.parent.deliciousKeyconfig) target = window.opener.parent;

if(target) {
	var gPrefService = target.deliciousKeyconfig.prefService;
	var gProfile = target.deliciousKeyconfig.profile;
	var gDocument = target.document;
	var gRemovedKeys = target.deliciousKeyconfig.removedKeys;
}

var gAtomService = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
var gUnicodeConverter = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
                                  .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
var gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                                 .getService(Components.interfaces.nsIClipboardHelper);
var gLocation, gKeys, gUsedKeys, gAllKeys;

var gExtra2, keyTree, gEditbox, gEdit, gModified;

var gLocaleKeys;
var gPlatformKeys = new Object();
var gVKNames = [];
var gReverseNames;

function initKeyConfig() {
	if(!target) return;

  if(!gPrefService.prefHasUserValue("extensions.delicious.keyconf.version"))
  	gPrefService.setIntPref("extensions.delicious.keyconf.version","1");
  gUnicodeConverter.charset = "UTF-8";

  keyTree = document.getElementById("key-tree");
  gEditbox = document.getElementById("editbox");
  gEdit = document.getElementById("edit");
  gLocaleKeys = document.getElementById("localeKeys");

  var platformKeys = document.getElementById("platformKeys");
  gPlatformKeys.shift = platformKeys.getString("VK_SHIFT");
  gPlatformKeys.meta  = platformKeys.getString("VK_META");
  gPlatformKeys.alt   = platformKeys.getString("VK_ALT");
  gPlatformKeys.ctrl  = platformKeys.getString("VK_CONTROL");
  gPlatformKeys.sep   = platformKeys.getString("MODIFIER_SEPARATOR");
  switch (gPrefService.getIntPref("ui.key.accelKey")){
    case 17:  gPlatformKeys.accel = gPlatformKeys.ctrl; break;
    case 18:  gPlatformKeys.accel = gPlatformKeys.alt; break;
    case 224: gPlatformKeys.accel = gPlatformKeys.meta; break;
    default:  gPlatformKeys.accel = (window.navigator.platform.search("Mac") == 0 ? gPlatformKeys.meta : gPlatformKeys.ctrl);
  }

  for (var property in KeyEvent) {
    gVKNames[KeyEvent[property]] = property.replace("DOM_","");
  }
  gVKNames[8] = "VK_BACK";

  var isThunderbird;
  if(Components.interfaces.nsIXULAppInfo) {
   var XULAppInfo = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo);
   isThunderbird = XULAppInfo.name == "Thunderbird";
  } else {
   isThunderbird = window.navigator.vendor == "Thunderbird";
  }

  gReverseNames = isThunderbird ^ gPrefService.getBoolPref("extensions.delicious.keyconf.nicenames.reverse_order");

  if(gPrefService.getBoolPref("extensions.delicious.keyconf.devmode")){ this.getFormattedKey = function(a,b,c) {return a+"+"+b+c;} }

  init(target);
}

function init(target) {
  if(!target) return;

  gDocument = target.document;
  gLocation = gDocument.location.href;

  gKeys = [];
  gAllKeys = [];
  gRemovedKeys = target.deliciousKeyconfig.removedKeys;

  var keys = gDocument.getElementsByTagName("key");

  for(var i = 0, l = keys.length; i < l; i++) {
  	var deliciousKey = keys[i].id;
  	var key = new Key(keys[i]);
  	if(deliciousKey.indexOf('deliciousKey') == 0) gKeys.push(key);
  	gAllKeys.push(key);
  }

  for(i = 0, l = gRemovedKeys.childNodes.length; i < l; i++) gKeys.push(new Key(gRemovedKeys.childNodes[i]));

  detectUsedKeys();

  var elem = keyTree.getElementsByAttribute("sortActive","true")[0];

  gKeys.sort(sorter[elem.id]);
  if(elem.getAttribute("sortDirection") == "descending") gKeys.reverse();

  keyTree.view = keyView;

  keyTree.view.selection.select(-1);
  gEditbox.setAttribute("disabled","true");
  gEdit.value = "";
  gEdit.keys = ["!","",""];
}

function getFormattedKey(modifiers,key,keycode) {
  var val = "";
  if(modifiers) val = modifiers
    .replace(/ $/,"")
    .replace(" ",",")
    .replace(",,",",")
    .replace(",",gPlatformKeys.sep)
    .replace("alt",gPlatformKeys.alt)
    .replace("shift",gPlatformKeys.shift)
    .replace("control",gPlatformKeys.ctrl)
    .replace("meta",gPlatformKeys.meta)
    .replace("accel",gPlatformKeys.accel)
  +gPlatformKeys.sep;
  if(key)
    val += key;
  if(keycode) try {
    val += gLocaleKeys.getString(keycode)
  } catch(e){val += gStrings.unrecognized.replace("$1",keycode);}

  return val;
}

function getNameForKey(aKey) {
  var val;

  if(aKey.hasAttribute("label")) return aKey.getAttribute("label");

  if(aKey.hasAttribute("command") || aKey.hasAttribute("observes")) {
    var command = aKey.getAttribute("command") || aKey.getAttribute("observes");
    var node = gDocument.getElementById(command);
    if(node && node.hasAttribute("label")) return node.getAttribute("label");
    val = getLabel("command", command);
    if(!val) val = getLabel("observes", command);
  }

  if(!val) val = getLabel("key", aKey.id);

  if(val) return val;

  var id = aKey.id.replace(/xxx_key.+?_/,"");
  try {id = gUnicodeConverter.ConvertToUnicode(id);} catch(err) { gUnicodeConverter.charset = "UTF-8"; }

  if(keyname[id]) {
    var key = gDocument.getElementById(keyname[id]);
    if(!key) key = gRemovedKeys.getElementsByAttribute("id",keyname[id])[0];
    if(key) return getNameForKey(key);
    return keyname[id];
  }

  return id;
}

function getLabel(attr, value) {
  var Users = gDocument.getElementsByAttribute(attr,value);
  var User;

  for(var i = 0, l = Users.length; i < l; i++)
    if(Users[i].hasAttribute("label") && (!User || User.localName == "menuitem")) User = Users[i];

  if(!User) return null;

  if(User.localName == "menuitem" && User.parentNode.parentNode.parentNode.localName == "menupopup") {
    if(gReverseNames) return User.parentNode.parentNode.getAttribute("label") + " > " + User.getAttribute("label");
    else return User.getAttribute("label") + " [" + User.parentNode.parentNode.getAttribute("label") + "]";
  } else return User.getAttribute("label");
}

function Recognize(event) {
  event.preventDefault();
  event.stopPropagation();

  var modifiers = [];
  if(event.altKey) modifiers.push("alt");
  if(event.ctrlKey) modifiers.push("control");
  if(event.metaKey) modifiers.push("meta");
  if(event.shiftKey) modifiers.push("shift");

  modifiers = modifiers.join(" ");

  var key = ""; var keycode = "";
  if(event.charCode) key = String.fromCharCode(event.charCode).toUpperCase();
  else { keycode = gVKNames[event.keyCode]; if(!keycode) return;}

  gEdit.value = getFormattedKey(modifiers,key,keycode);
  gEdit.keys = [modifiers,key,keycode];

  if(gPrefService.getBoolPref("extensions.delicious.keyconf.warnOnDuplicate") && gEdit.value != gEdit.key.shortcut && gUsedKeys[gEdit.value])
    alert(gStrings.used.replace("$1",gUsedKeys[gEdit.value].join("\n")));

  gEdit.select();
}

function Apply() {
  var key = gKeys[keyTree.currentIndex];
  var node = key.node;

  if(key.shortcut == gEdit.value) return;

  key.shortcut = gEdit.value;
  key.pref.splice(0,3,gEdit.keys[0],gEdit.keys[1],gEdit.keys[2]);

  gModified = true;
  detectUsedKeys();

  var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
  str.data = key.pref.join("][");
  gPrefService.setComplexValue(gProfile+node.id, Components.interfaces.nsISupportsString, str);

  node.removeAttribute("modifiers"); node.removeAttribute("key"); node.removeAttribute("keycode");
  node.removeAttribute("charcode");
  node.removeAttribute("deliciousKeyconfig");

  if(key.pref[0] == "!") gRemovedKeys.appendChild(node);

  if(key.pref[0] && key.pref[0] != "!") node.setAttribute("modifiers",key.pref[0]);
  if(key.pref[1]) node.setAttribute("key",key.pref[1]);
  if(key.pref[2]) node.setAttribute("keycode",key.pref[2]);

  keyTree.treeBoxObject.invalidate();
}

function Disable() {
  gEdit.value = "";
  gEdit.keys = ["!","",""];
  Apply();
}

function Reset() {
  var key = gKeys[keyTree.currentIndex];
  var node = key.node;

  try{ gPrefService.clearUserPref(gProfile+node.id); }catch(err){}

  key.pref = [];
  key.shortcut = gEdit.value = gStrings.onreset;
  gEdit.keys = ["!","",""];

  node.setAttribute("deliciousKeyconfig","resetted");

  gModified = true;
  detectUsedKeys();

  keyTree.treeBoxObject.invalidate();
}

function Key(aKey) {
  this.node = aKey;
  this.name = getNameForKey(aKey);
  this.shortcut = getFormattedKey(
    aKey.getAttribute("modifiers"),
    aKey.getAttribute("key").toUpperCase() || aKey.getAttribute("charcode").toUpperCase(),
    aKey.getAttribute("keycode")
  );
  this.id = aKey.id;
  if(aKey.getAttribute("deliciousKeyconfig") == "resetted") this.shortcut = gStrings.onreset;

  try {
    this.pref = gPrefService.getComplexValue(gProfile+aKey.id, Components.interfaces.nsISupportsString).data.split("][");
  } catch(err) { this.pref = []; }

  if(!aKey.hasAttribute("command") && !aKey.hasAttribute("oncommand")) this.hardcoded = true;
}

var sorter = {
  name: function(a,b) { return a.name.localeCompare(b.name); },
  id: function(a,b) { return a.id.localeCompare(b.id); },
  shortcut: function(a,b) {
    if(a.shortcut == b.shortcut) return 0;
    if(!a.shortcut) return 1;
    if(!b.shortcut) return -1;
    if(a.shortcut > b.shortcut) return 1;
    return -1;
  }
}

function detectUsedKeys() {
  gUsedKeys = [];

  for(var i = 0, l = gAllKeys.length; i < l; i++) {
    if(gUsedKeys[gAllKeys[i].shortcut])
      gUsedKeys[gAllKeys[i].shortcut].push(gAllKeys[i].name);
    else
      gUsedKeys[gAllKeys[i].shortcut]=[gAllKeys[i].name];
  }

  gUsedKeys[""] = gUsedKeys[gStrings.onreset] = {length: 0}
}

var keyView = {
  get rowCount() { return gKeys.length; },
  getCellText : function(row,col){ return gKeys[row][col.id || col];},
  setTree: function(treebox) { this.treebox=treebox; },
  isContainer: function() { return false; },
  isSeparator: function() { return false; },
  isSorted: function() { return false; },
  getLevel: function() { return 0; },
  getImageSrc: function() { return null; },
  getRowProperties: function() {},
  canDropBeforeAfter: function() { return false; },
  canDrop: function() { return false; },
  getParentIndex: function() { return -1; },

  getCellProperties: function(row,col,props) {
    var key = gKeys[row];
    if(key.hardcoded) props.AppendElement(gAtomService.getAtom("hardcoded"));
    if(key.pref[0] == "!") props.AppendElement(gAtomService.getAtom("disabled"));
    if(key.pref[3]) props.AppendElement(gAtomService.getAtom("custom"));
    if(key.pref.length) props.AppendElement(gAtomService.getAtom("user"));
    if((col.id || col) == "shortcut" && gUsedKeys[key.shortcut].length > 1)
      props.AppendElement(gAtomService.getAtom("duplicate"));
  },
  getColumnProperties: function(){},
  selectionChanged: function() {
    var key = gKeys[this.selection.currentIndex];

    if(!key) return;

    if(gEditbox.hasAttribute("disabled")) gEditbox.removeAttribute("disabled");
    gEdit.key = key;
    gEdit.value = key.shortcut;
  },
  cycleHeader: function cycleHeader(col, elem) {
    if(col.id) elem = col.element;

    var direction = elem.getAttribute("sortDirection") == "ascending" ? "descending" : "ascending";
    var columns = this.treebox.firstChild.childNodes;
    for(var i = 0, l = columns.length; i < l; i++) {
      columns[i].setAttribute("sortDirection","none");
      columns[i].setAttribute("sortActive",false);
    }

    elem.setAttribute("sortDirection",direction);
    elem.setAttribute("sortActive",true);

    var currentRow = gKeys[this.selection.currentIndex];

    gKeys.sort(sorter[col.id || col]);
    if(direction == "descending") gKeys.reverse();

    this.treebox.invalidate();
    if(currentRow) {
      i = -1;
      do { i++; } while(currentRow != gKeys[i]);
      this.selection.select(i);
      this.treebox.ensureRowIsVisible(i);
    }
  }
}
